dhtmlxGantt와 React 연동하기

이 튜토리얼은 JS DHTMLX Gantt를 React 애플리케이션 내에서 사용하는 방법을 안내합니다. 공식 React Gantt 컴포넌트에 대해서는 React Gantt 문서를 참고하세요.

이 가이드를 따라하기 전에 React의 기본 개념과 패턴을 이해하고 있으면 도움이 됩니다. React가 처음이라면 React documentation을 먼저 참고해보세요.

DHTMLX Gantt는 React와 잘 호환됩니다. 관련 예제는 GitHub에서 확인할 수 있습니다: DHTMLX Gantt with React Demo.

프로젝트 생성

새 프로젝트를 생성하기 전에 Node.js가 설치되어 있는지 확인하세요.

기본 React 프로젝트를 빠르게 생성하려면 다음 명령어를 실행하세요:

npx create-vite my-react-gantt-app --template react

의존성 설치

이제 프로젝트 폴더로 이동합니다. 프로젝트 이름이 my-react-gantt-app이라면 다음을 실행하세요:

cd my-react-gantt-app

이후, 의존성을 설치하고 개발 서버를 시작합니다. 사용하는 패키지 매니저에 따라 아래 명령어를 사용하세요:

  • yarn 사용 시:
yarn install
yarn dev
  • npm 사용 시:
npm install
npm run dev

이제 React 앱이 http://localhost:5173에서 실행됩니다.

Gantt React app running

Gantt 생성

다음으로, DHTMLX Gantt 코드를 받아봅니다. 먼저, 터미널에서 Ctrl+C를 눌러 실행 중인 앱을 중지하세요. 그런 다음 Gantt 패키지를 설치합니다.

1단계. 패키지 설치

라이브러리의 PRO 버전은 npm/yarn을 통해 당사 프라이빗 저장소에서 제공됩니다. 접근 권한을 얻으려면 이 안내를 참고하세요.

Evaluation(평가판) 버전을 받았다면 아래 명령어로 설치할 수 있습니다:

  • npm 사용 시:
npm install @dhx/trial-gantt
  • yarn 사용 시:
yarn add @dhx/trial-gantt

또는, 라이브러리 zip 패키지가 npm 모듈 구조이므로, 로컬 폴더에서 설치할 수도 있습니다.

2단계. 컴포넌트 생성

이제 React 컴포넌트를 만들어 앱에 Gantt를 통합해보겠습니다. src/ 디렉터리에 Gantt.jsx 파일을 새로 만듭니다.

소스 파일 임포트

Gantt.jsx를 열고 Gantt 소스 파일을 임포트합니다. 아래를 참고하세요:

  • Gantt 패키지를 로컬 폴더에서 설치했다면 임포트는 다음과 같습니다:

Gantt.jsx

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • 평가판(trial) 버전을 설치했다면 아래와 같이 임포트하세요:

Gantt.jsx

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

이 가이드에서는 trial 버전을 사용합니다.

컨테이너 설정 및 Gantt 추가

Gantt를 페이지에 렌더링하려면 컨테이너 요소가 필요합니다. Gantt.jsx 파일은 다음과 같이 작성합니다:

Gantt.jsx

import { useEffect, useRef } from "react"; import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default function GanttView() {   let container = useRef();  
  useEffect(() => {     let gantt = Gantt.getGanttInstance();     gantt.init(container.current);  
    return () => {       gantt.destructor();       container.current.innerHTML = "";     };   }, []);  
  return <div ref={container} style={ {width: "100%", height: "100%"} }></div>; }

3단계. Gantt를 앱에 추가

이제 앱에 Gantt 컴포넌트를 포함시킵니다. src/app.jsx를 열고 기본 내용을 아래로 교체하세요:

src/app.jsx

import Gantt from "./Gantt";
 
function App() {
  return <Gantt/>;
}
 
export default App;

Gantt 컨테이너가 전체 화면을 채우도록 하려면 src/index.css에서 기본 스타일을 제거하고 아래 스타일을 추가하세요:

src/index.css

html,
body,
#root {
  height: 100%;
  padding: 0;
  margin: 0;
}

앱을 다시 시작하면 빈 Gantt 차트가 표시됩니다:

Gantt React init

4단계. 데이터 제공

Gantt에 작업을 표시하려면 데이터셋을 제공해야 합니다. src/data.js 파일을 만들고 아래 내용을 추가하세요:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

이 데이터를 App.jsx에서 Gantt 컴포넌트의 props로 전달합니다:

App.jsx

import Gantt from "./Gantt";
import { getData } from "./data.js";
 
function App() {
  return <Gantt tasks={getData()} />;
}
 
export default App;

그리고 Gantt 컴포넌트 내에서 gantt.parse() 메소드에 props를 전달하세요:

Gantt.jsx

import { useEffect, useRef } from "react";
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default function GanttView(props) {
  let container = useRef();
 
  useEffect(() => {
    let gantt = Gantt.getGanttInstance();
    gantt.init(container.current);
    gantt.parse(props.tasks);  
    return () => {
      gantt.destructor();
      container.current.innerHTML = "";
    };
  }, []);
 
  return <div ref={container} style={ {width: "100%", height: "100%"} }></div>;
}

앱을 새로고침하면 작업이 표시된 Gantt 차트를 볼 수 있습니다:

Gantt tasks

5단계. 데이터 저장

Gantt에서 변경된 내용을 처리하려면 dataProcessor를 사용할 수 있습니다. dataProcessor는 백엔드와의 통신을 가능하게 해줍니다. dataProcessor는 함수 또는 라우터 객체로 정의할 수 있습니다. dhtmlxGantt는 handler에서 Promise 응답을 지원하므로, 작업을 적절히 처리할 수 있습니다.

createDataProcessor()DataProcessor를 생성하고 다음과 같이 변경사항을 감지할 수 있습니다:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

백엔드에서 레코드 생성 후 새로운 id를 할당하는 경우(일반적인 동작), Promise는 반드시 {id: databaseId} 또는 {tid: databaseId} 형태의 객체를 반환해야 Gantt에서 해당 레코드를 올바르게 업데이트할 수 있습니다. 자세한 내용은 server side integration을 참고하세요.

이렇게 하면 React Gantt가 준비됩니다. 전체 데모는 GitHub에서 확인할 수 있습니다: https://github.com/DHTMLX/react-gantt-demo.

XSS, CSRF 및 SQL Injection 공격

Gantt 자체는 SQL injection, XSS, CSRF와 같은 보안 위협에 대한 보호 기능을 제공하지 않습니다. 애플리케이션의 보안은 백엔드를 관리하는 개발자의 책임입니다.

일반적인 취약점과 보안 강화를 위한 권장 사항은 Application Security 문서를 참고하세요.

Back to top

dhtmlxGantt와 Vue.js 연동하기

이 가이드는 Vue의 기본 개념과 패턴을 이해하고 있다고 가정합니다. Vue가 처음이라면 Vue 3 공식 문서를 참고하여 빠르게 시작해 보세요.

DHTMLX Gantt는 Vue와 잘 호환됩니다. 관련 예제는 GitHub에서 확인할 수 있습니다: DHTMLX Gantt with Vue Demo.

프로젝트 생성

새 프로젝트를 시작하기 전에 Node.js가 설치되어 있는지 확인하세요.

Vue 프로젝트를 생성하려면 다음 명령어를 실행하세요:

npm create vue@latest

이 명령어는 공식 Vue 프로젝트 생성 도구인 create-vue를 설치하고 실행합니다. 자세한 내용은 Vue.js 빠른 시작에서 확인할 수 있습니다.

의존성 설치

다음으로, 앱 디렉터리로 이동하세요. 프로젝트 이름은 gantt-vue로 하겠습니다:

cd gantt-vue

패키지 매니저를 사용하여 의존성을 설치하고 개발 서버를 실행하세요:

  • yarn 사용 시:
yarn install
yarn dev
  • npm 사용 시:
npm install
npm run dev

이제 Vue 프로젝트가 http://localhost:5173에서 실행됩니다.

Gantt Vue app running

Gantt 생성

DHTMLX Gantt를 프로젝트에 추가하려면, 먼저 터미널에서 Ctrl+C를 눌러 실행 중인 앱을 중지하세요. 그 다음 Gantt 패키지를 설치합니다.

1단계. 패키지 설치

라이브러리의 PRO 버전은 당사 프라이빗 저장소에서 npm/yarn을 통해 설치할 수 있습니다. 접근 방법은 이 안내서를 참고하세요.

Evaluation 버전을 받았다면, 아래 명령어 중 하나로 설치하세요:

  • npm 사용 시:
npm install @dhx/trial-gantt
  • yarn 사용 시:
yarn add @dhx/trial-gantt

또는, 라이브러리 zip 패키지는 npm 모듈 구조이므로 로컬 폴더에서 설치할 수도 있습니다.

2단계. 컴포넌트 생성

Gantt를 앱에 임베드하기 위해 Vue 컴포넌트를 만듭니다. src/components/ 디렉터리에 Gantt.vue 파일을 추가하세요.

소스 파일 임포트

Gantt.vue를 열고 Gantt 소스 파일을 임포트합니다. 설치 방식에 따라 임포트 경로가 다릅니다:

  • 로컬 폴더에서 설치했다면:

Gantt.vue

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • trial 버전을 설치했다면:

Gantt.vue

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

이 가이드에서는 trial 버전을 사용합니다.

컨테이너 지정 및 Gantt 추가

Gantt를 페이지에 렌더링하려면 컨테이너 요소를 지정해야 합니다. 예시는 다음과 같습니다:

Gantt.vue

<script>
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default {
  mounted() {
    let gantt = Gantt.getGanttInstance();
    gantt.init(this.$refs.cont);
 
    this.gantt = gantt;
  },
  unmounted() {
    this.gantt.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100%"></div> </template>

Gantt 컨테이너가 전체 body를 채우게 하려면 src/assetsmain.css에서 기본 스타일을 제거하고 다음을 추가하세요:

src/assets/main.css

body, #app {
  margin: 0;
  padding: 0;
  height: 100vh;
  width: 100%;
}

3단계. 앱에 Gantt 추가

다음으로, Gantt 컴포넌트를 앱에 포함시킵니다. src/App.vue를 열고 기본 내용을 다음으로 교체하세요:

src/App.vue

<script>
import Gantt from "./components/Gantt.vue";
 
export default {
  components: { Gantt }
};
</script>   <template> <Gantt/> </template>

앱을 실행하면 빈 Gantt가 표시됩니다:

Gantt Vue init

4단계. 데이터 제공

Gantt에 태스크를 표시하려면 데이터셋을 제공해야 합니다. src/ 디렉터리에 data.js 파일을 만들고 아래 데이터를 입력하세요:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

이 데이터를 App.vue에서 Gantt 컴포넌트의 props로 전달하세요:

App.vue

<script>
import Gantt from "./components/Gantt.vue";
import { getData } from "./data";
 
export default {
  components: { Gantt },
  data() {
    return {
      tasks: getData(),
    };
  },
};
</script>   <template> <Gantt :tasks="tasks" /> </template>

그리고 Gantt 컴포넌트에서 gantt.parse()로 이 props를 사용하세요:

Gantt.vue

<script>
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default {
  props: ["tasks"],
 
  mounted() {
    let gantt = Gantt.getGanttInstance();
    gantt.init(this.$refs.cont);
    gantt.parse(this.tasks);
 
    this.gantt = gantt;
  },
  unmounted() {
    this.gantt.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100%"></div> </template>

앱 페이지를 새로고침하면 태스크가 표시된 Gantt를 볼 수 있습니다:

Gantt tasks

5단계. 데이터 저장

Gantt에서 변경된 내용을 추적하려면, 백엔드와의 통신을 관리하는 dataProcessor 핸들러를 사용하세요. 이 핸들러는 함수 또는 라우터 객체가 될 수 있습니다. dhtmlxGantt는 핸들러에서 Promise 반환을 지원하므로, 작업 완료 시점을 정확히 처리할 수 있습니다.

createDataProcessor()DataProcessor를 생성하고 변경 사항을 다음과 같이 감지할 수 있습니다:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

백엔드에서 새로운 레코드를 생성할 때 태스크 ID가 변경되는 경우(많은 시스템에서 일반적임), Promise에서 {id: databaseId} 또는 {tid: databaseId} 객체를 반환해야 합니다. 이를 통해 Gantt가 새 데이터베이스 ID로 레코드를 갱신할 수 있습니다. 자세한 내용은 server side integration을 참고하세요.

이로써 Vue Gantt 설정이 완료됩니다. 전체 데모는 GitHub에서 확인할 수 있습니다: https://github.com/DHTMLX/vue-gantt-demo.

XSS, CSRF 및 SQL Injection 공격

Gantt 자체는 SQL 인젝션, XSS, CSRF와 같은 위협에 대한 보호 기능을 제공하지 않습니다. 애플리케이션의 보안은 백엔드 개발자의 책임입니다.

일반적인 취약점과 앱 보안 강화 방법은 Application Security 문서를 참고하세요.

Back to top

dhtmlxGantt와 Angular 연동하기

이 가이드는 Angular의 기본 개념과 패턴에 대한 이해를 전제로 합니다. 복습이 필요하다면 Angular 공식 문서에서 시작 가이드를 참고하세요.

DHTMLX Gantt는 Angular와 원활하게 연동됩니다. 관련 예제는 GitHub에서 확인할 수 있습니다: DHTMLX Gantt with Angular Demo.

프로젝트 생성

새 프로젝트를 만들기 전에 Angular CLINode.js가 설치되어 있는지 확인하세요.

ng new my-angular-gantt-app

이 명령어는 필요한 도구와 의존성을 모두 설정해 주므로 추가 설치 명령은 필요하지 않습니다.

의존성 설치

다음으로 앱 디렉토리로 이동하세요:

cd my-angular-gantt-app

아래 명령어 중 하나로 앱을 실행할 수 있습니다:

yarn start

또는

npm start

앱은 이제 http://localhost:4200에서 접속할 수 있습니다.

Gantt Angular app running

Gantt 생성

다음 단계는 DHTMLX Gantt 코드를 가져오는 것입니다. 먼저 Ctrl+C로 앱 실행을 중지한 후, Gantt 패키지를 설치하세요.

1단계. 패키지 설치

라이브러리의 PRO 버전은 npm/yarn을 통해 당사 프라이빗 저장소에서 제공합니다. 액세스 방법은 이 안내를 참고하세요.

Gantt 평가판을 받았다면, 다음 명령어 중 하나로 설치하세요:

  • npm 사용 시:
npm install @dhx/trial-gantt
  • yarn 사용 시:
yarn add @dhx/trial-gantt

또는, zip 패키지는 npm 모듈 구조이므로 로컬 폴더에서 설치도 가능합니다.

2단계. 컴포넌트 생성

Gantt를 애플리케이션에 통합할 컴포넌트를 만듭니다. src/app/ 디렉토리 안에 gantt 폴더를 만들고, gantt.component.tsgantt.component.css 파일을 추가하세요.

소스 파일 가져오기

gantt.component.ts를 열고 Gantt 소스 파일을 가져오세요. 설치 방식에 따라 import 경로가 달라집니다:

  • 로컬 폴더에서 설치한 경우:

gantt.component.ts

import { Gantt } from 'dhtmlx-gantt';

gantt.component.css

@import "@dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • trial 버전을 사용하는 경우:

gantt.component.ts

import { Gantt } from '@dhx/trial-gantt';

gantt.component.css

@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

이 튜토리얼에서는 trial 버전을 사용합니다.

gantt.component.ts 파일은 Gantt 컴포넌트의 템플릿 역할을 합니다. 다음 코드를 추가하세요:

gantt.component.ts

import { Component, ElementRef, OnInit, 
    ViewChild, ViewEncapsulation } from '@angular/core';
import { Gantt, GanttStatic } from "@dhx/trial-gantt";
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})
export class GanttComponent implements OnInit {
    @ViewChild('gantt_here', { static: true }) ganttContainer!: ElementRef;
    private _gantt?: GanttStatic;
 
    ngOnInit() {
        let gantt = Gantt.getGanttInstance();
        gantt.init(this.ganttContainer.nativeElement);
 
        this._gantt = gantt;
    }
    ngOnDestroy() {
        if (this._gantt) this._gantt.destructor();
    }
}

여기서 ngOnInit() 메서드는 Gantt를 초기화하며, ngOnDestroy()는 컴포넌트가 제거될 때 gantt.destructor()를 호출하여 정리 작업을 수행합니다.

Gantt 스타일은 gantt.component.css에 작성합니다. 기본 스타일 예시는 다음과 같습니다:

gantt.component.css

@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
.gantt-chart {
    position: relative;
    width: 100%;
    height: 600px;
}

3단계. Gantt를 앱에 추가

다음으로, Gantt 컴포넌트를 앱에 포함시킵니다. src/app/app.component.ts를 열고 기본 내용을 아래와 같이 교체하세요:

src/app/app.component.ts

import { Component } from '@angular/core';
 
@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'DHTMLX Gantt with Angular';
}

src/app/app.module.ts를 생성하고 GanttComponent를 포함시키세요:

src/app/app.module.ts

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
 
import { AppComponent } from "./app.component";
import { GanttComponent } from './gantt/gantt.component';
 
@NgModule({
  declarations: [AppComponent, GanttComponent],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}

src/app/app.component.html의 기본 내용을 아래로 교체하세요:

src/app/app.component.html

<gantt></gantt>

마지막으로 src/main.ts의 내용을 다음과 같이 변경하세요:

src/main.ts

import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
 
platformBrowserDynamic()
  .bootstrapModule(AppModule)
  .catch((err) => console.error(err));

앱을 실행하면 빈 Gantt 차트가 표시됩니다:

Gantt Angular init

4단계. 데이터 제공

Angular Gantt에 데이터를 로드하려면 task와 link 서비스를 추가해야 합니다. 그 전에 task와 link 모델을 정의하세요.

아래 명령어로 task와 link 모델을 생성합니다:

ng generate class models/task --skip-tests
ng generate class models/link --skip-tests

models/task.ts 파일에 다음 내용을 추가하세요:

models/task.ts

export class Task {
    id!: number;
    start_date!: string;
    text!: string;
    progress!: number;
    duration!: number;
    parent!: number;
}

models/link.ts 파일에는 다음을 추가하세요:

models/link.ts

export class Link {
     id!: number;
    source!: number;
    target!: number;
    type!: string;
}

다음으로 task와 link 서비스를 생성합니다. Angular의 서비스는 특정 작업이나 기능을 처리하는 클래스이며, 필요한 곳에 주입할 수 있습니다.

서비스는 다음 명령어로 생성하세요:

ng generate service services/task --flat --skip-tests
ng generate service services/link --flat --skip-tests

services/task.service.ts 파일에 다음 코드를 추가하세요:

services/task.service.ts

import { Injectable } from '@angular/core';
import { Task } from '../models/task';
 
@Injectable()
export class TaskService {
    get(): Promise<Task[]>{
        return Promise.resolve([
            { id: 1, text: 'Task #1', start_date: '2023-04-15 00:00', 
                duration: 3, progress: 0.6, parent: 0 },
            { id: 2, text: 'Task #2', start_date: '2023-04-18 00:00', 
                duration: 3, progress: 0.4, parent: 0 }
        ]);
    }
}

services/link.service.ts 파일에는 다음을 추가하세요:

services/link.service.ts

import { Injectable } from '@angular/core';
import { Link } from '../models/link';
 
@Injectable()
export class LinkService {
    get(): Promise<Link[]> {
        return Promise.resolve([
            { id: 1, source: 1, target: 2, type: '0' }
        ]);
    }
}

@Injectable() 데코레이터는 Angular의 의존성 주입 시스템이 해당 서비스를 인스턴스화할 수 있게 해줍니다. get() 메서드는 현재 하드코딩된 데이터를 Promise로 반환하지만, 서버에서 데이터를 가져오도록 수정할 수도 있습니다.

이제 Gantt 컴포넌트에서 이 서비스들을 사용하려면 gantt.component.ts에서 import 하세요:

gantt.component.ts

import {TaskService} from "../services/task.service";
import {LinkService} from "../services/link.service";

@Component 데코레이터의 providers에 서비스를 추가하세요:

gantt.component.ts

@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    providers: [TaskService, LinkService],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})

이렇게 하면 GanttComponent가 생성될 때마다 각 서비스의 새 인스턴스가 생성됩니다.

생성자에 서비스를 주입하는 코드를 추가하세요:

gantt.component.ts

constructor(private taskService: TaskService, private linkService: LinkService) { }

ngOnInit()를 업데이트해서 날짜 포맷을 설정하고, Gantt를 초기화한 후 서비스에서 데이터를 불러오세요:

gantt.component.ts

let gantt = Gantt.getGanttInstance();
gantt.config.date_format = '%Y-%m-%d %H:%i';
gantt.init(this.ganttContainer.nativeElement);
 
Promise.all([this.taskService.get(), this.linkService.get()])
    .then( ([data, links]) => {
        gantt.parse({ data, links });
    });
this._gantt = gantt;

gantt.component.ts 전체 코드는 아래와 같습니다:

gantt.component.ts

import { Component, ElementRef, OnInit, 
    ViewChild, ViewEncapsulation } from '@angular/core';
import { TaskService } from '../services/task.service';
import { LinkService } from '../services/link.service';
import { Gantt, GanttStatic } from "@dhx/trial-gantt";
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    providers: [TaskService, LinkService],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})
export class GanttComponent implements OnInit {
    @ViewChild('gantt_here', { static: true }) ganttContainer!: ElementRef;
    private _gantt?: GanttStatic;
    constructor(private taskService: TaskService, private linkService: LinkService) { }
 
    ngOnInit() {
        let gantt = Gantt.getGanttInstance();
        gantt.config.date_format = '%Y-%m-%d %H:%i';
        gantt.init(this.ganttContainer.nativeElement);
        Promise.all([this.taskService.get(), this.linkService.get()])
            .then(([data, links]) => {
                gantt.parse({ data, links });
            });
        this._gantt = gantt;
    }
    ngOnDestroy() {
        if (this._gantt) this._gantt.destructor();
    }
}

이제 앱을 새로고침하면 작업이 채워진 Gantt 차트가 나타납니다:

Gantt Angular events

5단계. 데이터 저장

Gantt에서 변경 사항을 추적하려면 dataProcessor 핸들러를 사용할 수 있습니다. 이 핸들러를 통해 서버와 통신할 수 있으며, 함수나 라우터 객체로 설정할 수 있습니다. dhtmlxGantt는 핸들러에서 Promise를 반환하는 것도 지원하여, 작업 완료 시점을 적절히 처리할 수 있습니다.

createDataProcessor() API 메서드를 사용해 DataProcessor를 생성하고 다음과 같이 변경 사항을 감지할 수 있습니다:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

서비스에서 새 레코드를 추가한 후 task id를 수정하는 경우(일반적임), Promise가 {id: databaseId} 또는 {tid: databaseId} 객체를 반환하도록 해야 합니다. 이렇게 하면 Gantt가 새 데이터베이스 id로 레코드를 업데이트할 수 있습니다. 자세한 내용은 서버 사이드 정보를 참고하세요.

이제 Angular Gantt가 모두 준비되었습니다. GitHub의 전체 데모를 참고해 더 다양한 기능을 확인해보세요.

XSS, CSRF 및 SQL 인젝션 공격

Gantt 자체는 SQL 인젝션, XSS, CSRF와 같은 보안 위협에 대한 보호 기능을 제공하지 않습니다. 애플리케이션의 보안은 백엔드 개발자의 책임입니다.

구성 요소의 취약 지점과 애플리케이션 보안을 강화할 수 있는 방법은 Application Security 문서를 참고하세요.

Back to top

dhtmlxGantt와 Svelte 연동

이 가이드는 Svelte의 기본 개념과 패턴에 대한 이해를 전제로 합니다. 아직 익숙하지 않다면 Svelte 공식 문서에서 시작 가이드를 참고하세요.

DHTMLX Gantt는 Svelte와 잘 호환됩니다. 동작하는 예제는 GitHub에서 확인할 수 있습니다: DHTMLX Gantt with Svelte Demo.

프로젝트 생성

새 프로젝트를 시작하기 전에 Vite (선택 사항)와 Node.js가 설치되어 있는지 확인하세요.

Svelte 프로젝트를 설정하려면 Vite를 사용합니다. 아래 명령어를 실행하세요:

npm create vite@latest

자세한 내용은 관련 문서를 참고하세요.

의존성 설치

다음으로, 앱 디렉토리로 이동합니다. 프로젝트 이름을 gantt-svelte로 하고, svelte 옵션을 선택하세요. 그런 다음 아래 명령어를 실행합니다:

cd gantt-svelte

이제 원하는 패키지 매니저를 사용해 의존성을 설치하고 앱을 실행합니다:

  • yarn을 사용하는 경우:
yarn install
yarn dev
  • npm을 사용하는 경우:
npm install
npm run dev

Svelte 프로젝트가 이제 http://localhost:5173에서 실행됩니다.

Gantt Svelte app running

Gantt 추가하기

DHTMLX Gantt를 추가하려면, 먼저 터미널에서 Ctrl+C를 눌러 앱을 중지하세요. 이후 Gantt 패키지를 설치합니다.

1단계. 패키지 설치

라이브러리의 PRO 버전은 사설 저장소를 통해 npm/yarn으로 제공됩니다. 접근 권한을 얻으려면 이 안내를 따라주세요.

평가판을 받았다면 다음과 같이 설치합니다:

  • npm 사용 시:
npm install @dhx/trial-gantt
  • yarn 사용 시:
yarn add @dhx/trial-gantt

또는, 라이브러리 zip 패키지는 npm 모듈 구조이므로 로컬 폴더에서 설치할 수도 있습니다.

2단계. 컴포넌트 생성

이제 Svelte 컴포넌트를 만들어 앱에 Gantt를 포함시킵니다. src/ 폴더에 Gantt.svelte 파일을 새로 만드세요.

소스 파일 임포트

Gantt.svelte 파일을 열고 Gantt 소스 파일을 임포트합니다. 참고:

  • Gantt 패키지를 로컬 폴더에서 설치했다면, 임포트는 아래와 같습니다:

Gantt.svelte

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • 평가판을 설치했다면, 아래와 같이 임포트하세요:

Gantt.svelte

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

이 가이드에서는 trial 버전을 사용합니다.

컨테이너 설정 및 Gantt 추가

페이지에 Gantt를 표시하려면, 컴포넌트가 렌더링될 컨테이너를 정의하세요. 예시는 다음과 같습니다:

Gantt.svelte

<script>
    import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
    import { onMount } from "svelte";
    import { Gantt } from "@dhx/trial-gantt";
 
    let container;
    onMount(() => {
        let gantt = Gantt.getGanttInstance();
        gantt.init(container);
 
        return () => {
            gantt.destructor();
        };
    });
</script>   <div bind:this={container} style="width: 100%; height: 100%;"></div>

Gantt 컨테이너가 전체 body를 채우도록 하려면, src/ 폴더 내 app.css에서 기본 스타일을 제거하고 아래를 추가하세요:

src/app.css

body, #app {
  margin: 0;
  padding: 0;
  height: 100vh;
  width: 100%;
}

3단계. 앱에 Gantt 추가

이제 Gantt 컴포넌트를 앱에 포함시킵니다. src/App.svelte를 열고 기본 내용을 아래로 교체하세요:

src/App.svelte

<script>
  import Gantt from "./Gantt.svelte";
</script>
 
<Gantt/>

이제 앱을 실행하면 빈 Gantt 차트가 표시됩니다:

Gantt Svelte init

4단계. 데이터 제공

Gantt에 데이터를 표시하려면, 데이터를 전달해야 합니다. src/data.js 파일을 만들고 아래와 같이 작성하세요:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

이 데이터를 App.svelte에서 Gantt 컴포넌트의 props로 전달하세요:

App.svelte

<script>
  import Gantt from "./Gantt.svelte";
  import { getData } from "./data.js";
</script>   <Gantt tasks={getData()} />

그리고 Gantt 컴포넌트 내부에서 gantt.parse()를 사용해 props를 적용하세요:

Gantt.svelte

<script>
    import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
    import { onMount } from "svelte";
    import { Gantt } from "@dhx/trial-gantt";
 
    export let tasks;
 
    let container;
    onMount(() => {
        let gantt = Gantt.getGanttInstance();
        gantt.init(container);
        gantt.parse(tasks);
 
        return () => {
            gantt.destructor();
        };
    });
</script>   <div bind:this={container} style="width: 100%; height: 100%;"></div>

앱을 새로고침하면 작업이 채워진 Gantt 차트를 볼 수 있습니다:

Gantt tasks

5단계. 데이터 저장

Gantt에서 변경 사항을 추적하려면 dataProcessor 핸들러를 사용할 수 있습니다. 이 핸들러는 백엔드와의 통신을 돕고, 함수 또는 라우터 객체로 정의할 수 있습니다. dhtmlxGantt는 Promise 응답을 지원하여 작업이 올바르게 처리됩니다.

createDataProcessor()를 사용해 DataProcessor를 생성하여 변경 사항을 감지할 수 있습니다:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

백엔드에서 새 레코드 생성 후 task ID를 변경하는 경우, Promise가 {id: databaseId} 또는 {tid: databaseId} 객체를 반환해야 Gantt가 해당 레코드를 올바르게 갱신할 수 있습니다. 서버 사이드 연동에 대한 자세한 내용은 여기에서 확인하세요.

이제 Svelte Gantt 설정이 완료되었습니다. 전체 데모는 GitHub에서 확인할 수 있습니다: https://github.com/DHTMLX/svelte-gantt-demo.

XSS, CSRF, SQL Injection 공격

Gantt는 SQL 인젝션, XSS, CSRF 공격과 같은 위협에 대한 내장 보호 기능을 제공하지 않습니다. 이러한 위험으로부터 애플리케이션을 보호하는 것은 백엔드 개발자의 책임입니다.

잠재적 취약점과 권장 보안 관행에 대한 자세한 내용은 Application Security 문서를 참고하세요.

Back to top